#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#define LINEPIX 2220
#define LINEPIY 1360
#define NLOOP 100
#define NDATA 100000
#define SEARCH 200

void radec2xy(float ra0,float dec0,double ra,double dec,float *x,float *y){
  ra0*=M_PI/180;
  dec0*=M_PI/180;
  ra*=M_PI/180;
  dec*=M_PI/180;
  *y=asin(sin(dec)*cos(dec0)-cos(dec)*cos(ra-ra0)*sin(dec0));
  *x=asin(cos(dec)*sin(ra-ra0)/cos(*y));
  *x*=180/M_PI;
  *y*=180/M_PI;
}

void xy2radec(float ra0,float dec0,double *ra,double *dec,float x,float y){
  ra0*=M_PI/180;
  dec0*=M_PI/180;
  x*=M_PI/180;
  y*=M_PI/180;
  *dec=asin(cos(y)*cos(x)*sin(dec0)+sin(y)*cos(dec0));
  *ra=atan(cos(y)*sin(x)/(cos(y)*cos(x)*cos(dec0)-sin(y)*sin(dec0)))+ra0;
  *dec*=180/M_PI;
  *ra*=180/M_PI;
}

int main(int argc,char *argv[])
{
  FILE *fp,*fp0,*fpw;
  char buf[1024],dmy[1024],*adr,fname[32];
  float x[NDATA],y[NDATA],r,x0,y0,dx,dy,dx0,dy0,dx0_,dy0_,mg0,mg[NDATA],mg0min,mg0p,err,crval1,crval2,cd1_1,cd1_2,cd2_1,cd2_2,xt,yt,xi,yi,x_[2][2],y_[2][2],dr_[2],dmg,nmg0,nav,nsg;
  float dis3[3]={4.407,3.592,3.515},dis5[3]={3.651,3.659,3.424};
  //float dis3[3]={0.,0.,0.},dis5[3]={0.,0.,0.};//歪曲解析の場合
  double ra0,dec0,ra,dec,dr,drmin,sn,cs,en,rt,dxs,dys,rr0,rr,r0s,rs,as,dmgs,dmg2s,av,sg,thre,threm,threr,dr2s,drm,en_,rt_,dnmgs,dnmg2s;
  int crpix1,crpix2,detid,n,lp,ncol,k,nr,nm,nt,px,py,nmin,n0,ndat,dpx[3]={-8,8,0},dpy[3]={1,-9,8},nsc,ncrpix;

  if(argc != 4 && argc!=8){
    fprintf(stderr,"Usage : %s coo catalog column [dx dy enl rot]\n",argv[0]);
    exit(0);
  }
  fprintf(stderr,"Read: crpix.dat ... ");
  if((fp = fopen("crpix.dat","r")) == NULL){
    fprintf(stderr,"Cannot open ... Auto-generation mode.\n");
    ncrpix=1;
  }
  else{
    fscanf(fp,"%d %d %f %f",&px,&py,&crval1,&crval2);
    fclose(fp);
    fprintf(stderr,"OK\n");
    ncrpix=0;
  }
  sscanf(argv[3],"%d",&ncol);
  if(argc==8){
    sscanf(argv[4],"%f",&dx0);
    sscanf(argv[5],"%f",&dy0);
    sscanf(argv[6],"%lf",&en);
    sscanf(argv[7],"%lf",&rt);
  }
  else{
    dx0=0.;
    dy0=0.;
    en=1.;
    rt=0.;
  }
  fprintf(stderr,"Read: %s ...\n",argv[1]);
  if((fp = fopen(argv[1],"r")) == NULL){
    fprintf(stderr,"Cannot open %s\n",argv[1]);
    exit(0);
  }
  fgets(buf,sizeof(buf),fp);
  if(buf[0]!='#'&&buf[1]!=' '){
    fprintf(stderr,"The first character of %s must be '#'\n",argv[1]);
    exit(0);
  }
  if(sscanf(buf,"%s %f %f %d %d %f %f %f %f %d",dmy,&xt,&yt,&crpix1,&crpix2,&cd1_1,&cd1_2,&cd2_1,&cd2_2,&detid)!=10){
    fprintf(stderr,"The first line of %s must contain 9 data\n",argv[1]);
    exit(0);
  }
  if(ncrpix){
    crval1=xt;
    crval2=yt;
  }
  //fprintf(stderr,"%9.5f %9.5f %4d %4d %9.2e %9.2e %9.2e %9.2e\n",crval1,crval2,crpix1,crpix2,cd1_1,cd1_2,cd2_1,cd2_2);
  fprintf(stderr,"Read: %s ...\n",argv[2]);
  if((fp0 = fopen(argv[2],"r")) == NULL){
    fprintf(stderr,"Cannot open %s\n",argv[2]);
    exit(0);
  }
  n=0;n0=0;
  x_[1][0]=0./0.;x_[1][1]=0./0.;
  while(!feof(fp0)){
    if(fgets(buf,sizeof(buf),fp0)==NULL) continue;
    if(strspn(buf,"0123456789")==0&&strspn(buf+1,"0123456789")==0&&strspn(buf+2,"0123456789")==0) continue;
    if(sscanf(buf,"%lf %lf",&ra,&dec)!=2) continue;
    radec2xy(crval1,crval2,ra,dec,&xt,&yt);
    x[n]=( cd2_2*xt-cd1_2*yt)/(cd1_1*cd2_2-cd1_2*cd2_1)+crpix1;
    y[n]=(-cd2_1*xt+cd1_1*yt)/(cd1_1*cd2_2-cd1_2*cd2_1)+crpix2;
    strcpy(dmy,buf);
    adr=strtok(dmy," ");
    for(k=0;k<ncol-1;k++){
      adr=strtok(NULL," ");
      if(adr==NULL) break;
    }
    if(adr==NULL) continue;
    sscanf(adr,"%f",&mg[n]);
    if(buf[strlen(buf)-3]==' '&&buf[strlen(buf)-2]=='A'){x_[1][0]=x[n];y_[1][0]=y[n];}
    else if(buf[strlen(buf)-3]==' '&&buf[strlen(buf)-2]=='B'){x_[1][1]=x[n];y_[1][1]=y[n];}
    //if(n==3149) fprintf(stderr,"%g %g %g %g %s|%c\n",x[n],y[n],x_[1][0],y_[1][0],buf,buf[strlen(buf)-2]);
    if(sqrt((x[n]-crpix1)*(x[n]-crpix1)+(y[n]-crpix2)*(y[n]-crpix2))<SEARCH){
      if(n0==0) n0=n;
      else if(mg[n0]>mg[n]) n0=n;
    }
    n++;
    if(n==NDATA){
      fprintf(stderr,"NDATA is too small.\n");
      exit(0);
    }
  }
  ndat=n;
  mg0p=0.;
  while(1){
    if(argc==4){
      x_[0][0]=0./0.;x_[0][1]=0./0.;
      mg0min=100.;
      fseek(fp,0L,SEEK_SET);
      while(!feof(fp)){
	if(fgets(buf,sizeof(buf),fp)==NULL) continue;
	if(buf[0]=='#') continue;
	if(sscanf(buf,"%f %f %f %f",&xt,&yt,&mg0,&err)!=4){
	  fprintf(stderr,"Truncated data?: %s",buf);
	  exit(0);
	}
	r=sqrt((xt-LINEPIX/2)*(xt-LINEPIX/2)+(yt-LINEPIY/2)*(yt-LINEPIY/2))/1000;
	xt-=r*r*(dis3[detid]+r*r*dis5[detid])*(xt-LINEPIX/2)/1000;
	yt-=r*r*(dis3[detid]+r*r*dis5[detid])*(yt-LINEPIY/2)/1000;
	//fprintf(stderr,"%g %g %g %d %g %g %g %g %g %g",xt,yt,mg0,n0,x[n0],y[n0],sqrt((x[n0]-xt)*(x[n0]-xt)+(y[n0]-yt)*(y[n0]-yt)),x0,y0,mg0min);getchar();
	if(sqrt((x[n0]-xt)*(x[n0]-xt)+(y[n0]-yt)*(y[n0]-yt))<SEARCH){
	  if(mg0min>mg0&&mg0>mg0p){
	    mg0min=mg0;
	    x0=xt;y0=yt;
	  }
	}
	if(buf[strlen(buf)-3]==' '&&buf[strlen(buf)-2]=='A'){x_[0][0]=xt;y_[0][0]=yt;}
	else if(buf[strlen(buf)-3]==' '&&buf[strlen(buf)-2]=='B'){x_[0][1]=xt;y_[0][1]=yt;}
      }
      if(mg0min>99){
	fprintf(stderr,"No bright star found around (%g %g) %gmag\n",x[n0],y[n0],mg[n0]);
	exit(1);
      }else fprintf(stderr,"Bright star @(%g %g) %gmag => (%g %g) %gmag\n",x[n0],y[n0],mg[n0],x0,y0,mg0min);
      if(isnan(x_[0][0])==0&&isnan(x_[1][0])==0){
	dx0=x_[1][0]-x_[0][0];
	dy0=y_[1][0]-y_[0][0];
	//fprintf(stderr,"%g %g %g %g %g %g\n",x_[1][0],x_[0][0],dx0,y_[1][0],y_[0][0],dy0);
	if(isnan(x_[0][1])==0&&isnan(x_[1][1])==0){
	  for(n=0;n<2;n++){
	    x_[n][1]-=x_[n][0];
	    y_[n][1]-=y_[n][0];
	    dr_[n]=sqrt(x_[n][1]*x_[n][1]+y_[n][1]*y_[n][1]);
	  }
	  en=dr_[1]/dr_[0];
	  rt=asin((x_[0][1]*y_[1][1]-x_[1][1]*y_[0][1])/dr_[1]/dr_[0])/M_PI*180.;
	  //fprintf(stderr,"%g %g %g %g %g %g %g %g\n",x_[0][1],y_[0][1],dr_[0],x_[1][1],y_[1][1],dr_[1],en,rt);
	}
	else{
	  if(isnan(x_[0][1])!=0) fprintf(stderr,"No Star B in %s\n",argv[1]);
	  if(isnan(x_[1][1])!=0) fprintf(stderr,"No Star B in %s\n",argv[2]);
	  en=1.;rt=0.;
	}      
      }
      else{
	if(isnan(x_[0][0])!=0) fprintf(stderr,"No Star A in %s\n",argv[1]);
	if(isnan(x_[1][0])!=0) fprintf(stderr,"No Star A in %s\n",argv[2]);
	dx0=x[n0]-x0;dy0=y[n0]-y0;en=1.;rt=0.;
	x_[0][0]=crpix1;y_[0][0]=crpix2;
	x_[1][0]=crpix1+dx0;y_[1][0]=crpix2+dy0;
      }
    }
    else{
      x_[0][0]=crpix1;y_[0][0]=crpix2;
      x_[1][0]=crpix1+dx0;y_[1][0]=crpix2+dy0;
    }
    cs=cos(rt/180*M_PI);
    sn=sin(rt/180*M_PI);
    x0=((x_[0][0]-crpix1)*cs-(y_[0][0]-crpix2)*sn)*en+crpix1;
    y0=((x_[0][0]-crpix1)*sn+(y_[0][0]-crpix2)*cs)*en+crpix2;
    dx0=x_[1][0]-x0;
    dy0=y_[1][0]-y0;
    threm=30.;threr=60.;
    fprintf(stderr,"  dx       dy       enl      rot      dmag     sigm     sigp rejected\n");
    fprintf(stderr," %8.2lf %8.2lf %8.5lf %8.5lf\n",dx0,dy0,en,rt);
    fpw = fopen("chkcoo.dat","w");
    for(lp=NLOOP;lp>=0;lp--){
      cs=cos(rt/180*M_PI);
      sn=sin(rt/180*M_PI);
      fseek(fp,0L,SEEK_SET);
      dxs=0.;dys=0.;r0s=0.;rs=0.;as=0.;dmgs=0.;dmg2s=0.;nr=0;nm=0;nt=0;dr2s=0.;dnmgs=0.;dnmg2s=0.;
      while(!feof(fp)){
	if(fgets(buf,sizeof(buf),fp)==NULL) continue;
	if(buf[0]=='#') continue;
	nsc=sscanf(buf,"%f %f %f %f %f",&xi,&yi,&mg0,&err,&nmg0);
	if(nsc<4){
	  fprintf(stderr,"Truncated data?: %s",buf);
	  exit(0);
	}
	if(nsc==4) nmg0=0;
	r=sqrt((xi-LINEPIX/2)*(xi-LINEPIX/2)+(yi-LINEPIY/2)*(yi-LINEPIY/2))/1000;
	xi-=r*r*(dis3[detid]+r*r*dis5[detid])*(xi-LINEPIX/2)/1000;
	yi-=r*r*(dis3[detid]+r*r*dis5[detid])*(yi-LINEPIY/2)/1000;
	x0=((xi-crpix1)*cs-(yi-crpix2)*sn)*en+crpix1;
	y0=((xi-crpix1)*sn+(yi-crpix2)*cs)*en+crpix2;
	drmin=180.;
	for(n=0;n<ndat;n++){
	  dx=x[n]-(x0+dx0);
	  dy=y[n]-(y0+dy0);
	  dr=sqrt(dx*dx+dy*dy);
	  if(drmin>dr){
	    drmin=dr;
	    nmin=n;
	  }
	}
	dx=x[nmin]-(x0+dx0);
	dy=y[nmin]-(y0+dy0);
	dr=sqrt(dx*dx+dy*dy);
	if(lp==0){
	  if(ncrpix){
	    px=crpix1-dx0-dpx[detid];
	    py=crpix2-dy0-dpy[detid];
	  }
	  xt=x0+dx0-crpix1;
	  yt=y0+dy0-crpix2;
	  xy2radec(crval1,crval2,&ra0,&dec0,cd1_1*xt+cd1_2*yt,cd2_1*xt+cd2_2*yt);
	  xt+=px;
	  yt+=py;
	  //xt=xi;yt=yi;//歪曲解析の場合
	  if(dr>20) printf("#%8.3f %8.3f %10.6lf %10.6lf %6.3f %5.3f %6.2lf %6.2lf\n",xt,yt,ra0,dec0,mg0+av,err,dx,dy);
	  else{
	    fseek(fp0,0L,SEEK_SET);
	    n=0;
	    while(!feof(fp0)){
	      if(fgets(buf,sizeof(buf),fp0)==NULL) continue;
	      if(strspn(buf,"0123456789")==0&&strspn(buf+1,"0123456789")==0&&strspn(buf+2,"0123456789")==0) continue;
	      if(sscanf(buf,"%lf %lf",&ra,&dec)!=2) continue;
	      strcpy(dmy,buf);
	      adr=strtok(dmy," ");
	      for(k=0;k<ncol-1;k++){
		adr=strtok(NULL," ");
		if(adr==NULL) break;
	      }
	      if(adr==NULL) continue;
	      if(n==nmin) break;
	      n++;
	    }
	    printf("%8.3f %8.3f %10.6lf %10.6lf %6.3f %5.3f %6.2lf %6.2lf %s",xt,yt,ra0,dec0,mg0+av,err,dx,dy,buf);
	    dmg=(22-mg[nmin])/4;
	    if(dmg<0.5) dmg=0.5;
	    fprintf(fpw,"%8.3f %8.3f %6.3f",xt,yt,dmg*0.75);
	    dmg=mg[nmin]-mg0-av;
	    if(dmg < -0.15){fprintf(fpw," 0xff0000");}
	    else if(dmg < -0.05){fprintf(fpw," 0xff00ff");}
	    else if(dmg<0.05){fprintf(fpw," 0x00ff00");}
	    else if(dmg<0.15){fprintf(fpw," 0x00ffff");}
	    else {fprintf(fpw," 0x0000ff");}
	    fprintf(fpw," %6.2lf %6.2lf %6.3f %6.3f %5.3f\n",dx,dy,mg[nmin],mg0+av,err);
	  }
	}
	if(fabs(mg[nmin]-mg0-av)<threm && mg[nmin]<(NLOOP-lp)*0.5+20.){
	  if(200.<x0 && x0<LINEPIX-200 && dr<threr){
	    dxs+=x[nmin]-x0;
	    dys+=y[nmin]-y0;
	    rr=sqrt((x[nmin]-dx0-crpix1)*(x[nmin]-dx0-crpix1)+(y[nmin]-dy0-crpix2)*(y[nmin]-dy0-crpix2));
	    rr0=sqrt((x0-crpix1)*(x0-crpix1)+(y0-crpix2)*(y0-crpix2));
	    rs+=rr;
	    r0s+=rr0;
	    as+=((x0-crpix1)*(y[nmin]-dy0-crpix2)-(x[nmin]-dx0-crpix1)*(y0-crpix2))/rr;
	    dr2s+=dr*dr;
	    nr++;
	  }
	  dmgs+=mg[nmin]-mg0;
	  dmg2s+=(mg[nmin]-mg0)*(mg[nmin]-mg0);
	  dnmgs+=nmg0;
	  dnmg2s+=nmg0*nmg0;
	  nm++;
	  //fprintf(stderr,"%g %g %g %g %g %d",mg[nmin],mg0,av,threm,dmgs,nm);getchar();
	}
	nt++;
      }
      dx0=dxs/nr;
      dy0=dys/nr;
      en*=rs/r0s;
      rt+=asin(as/r0s)/M_PI*180.;
      av=dmgs/nm;
      sg=sqrt(dmg2s/nm-av*av);
      nav=dnmgs/nm;
      nsg=sqrt(dnmg2s/nm-nav*nav);
      drm=sqrt(dr2s/nr);
      fprintf(stderr," %8.2lf %8.2lf %8.5lf %8.5lf %8.5lf %8.5lf %5.2lf %d/%d/%d\n",dx0,dy0,en,rt,av,sg,drm,nt-nm,nm-nr,nt);
      if(lp!=NLOOP && lp!=0){
	if(lp<NLOOP-5 && drm>10.) break;
	if(fabs(dx0-dx0_)<1e-2 && fabs(dy0-dy0_)<1e-2 && fabs(en-en_)<1e-5 && fabs(rt-rt_)<1e-2 && lp>3) lp=3;
	dx0=(dx0+dx0_)/2;
	dy0=(dy0+dy0_)/2;
	en=(en+en_)/2;
	rt=(rt+rt_)/2;
      }
      dx0_=dx0;
      dy0_=dy0;
      en_=en;
      rt_=rt;
      thre=sqrt(nr)/2;
      if(thre>3.) thre=3.;
      else if(thre<1.5) thre=1.5;
      threm=sqrt(sg*thre*sg*thre+0.03*0.03);
      threr=sqrt(drm*thre*drm*thre+0.2*0.2);
      //fprintf(stderr,"%g %g %g %g %g\n",thre,sg,threm,drm,threr);
    }
    if(argc!=4) break;
    if(drm<=10. && nr>=4) break;
    if(nr<4) fprintf(stderr,"Number of the valid star < 4.");
    else fprintf(stderr,"Too large sigp.");
    fprintf(stderr," Search next bright star.\n");
    mg0p=mg0min;
  }
  if(nav>1.) fprintf(stderr,"Limiting mag (1σ) = %g±%g\n",nav+av,nsg);
  fprintf(stderr,"Write: chkcoo.dat ... OK\n");
  fclose(fpw);
  fclose(fp0);
  fclose(fp);
  fprintf(stderr,"Append: chkcoo.log ...\n");
  if((fp = fopen("chkcoo.log","a")) == NULL){
    fprintf(stderr,"Cannot open chkcoo.log\n");
  }
  else{
    fprintf(fp,"%s %8.2lf %8.2lf %8.5lf %8.5lf %8.5lf %8.5lf %5.2lf %d/%d/%d\n",argv[1],dx0,dy0,en,rt,av,sg,drm,nt-nm,nm-nr,nt);
    fclose(fp);
  }
  if(nr<4){fprintf(stderr,"##### Worning!!! Number of the valid star is %d. #####  (Press enter)",nr);getchar();}
  if(ncrpix){
    fprintf(stderr,"Write: crpix.dat ... ");
    fp = fopen("crpix.dat","w");
    fprintf(fp,"%d %d %9.5f %9.5f\n",px,py,crval1,crval2);
    fclose(fp);
    fprintf(stderr,"OK\n");
  }
  sscanf(argv[1],"%s",fname);
  fname[strlen(fname)-4]='\0';
  sprintf(buf,"../fitswarp %s.fits %sc.fits %lf %lf %d %d %lf %lf %lf adj",fname,fname,rt,en,crpix1,crpix2,dx0,dy0,pow(10.,-(av+2.5)/2.5));
  fprintf(stderr,"%s\n",buf);
  system(buf);
  sprintf(buf,"gnuplot < ../chkcoo.plt");
  fprintf(stderr,"%s\n",buf);
  system(buf);
  return 0;
}
