#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define LINEPIX 2220
#define LINEPIY 1360
#define NDATA 10000

int main(int argc,char *argv[])
{
  FILE *fp[2],*fpr,*fpw;
  char buf[1024],fname[128];
  float x[NDATA],y[NDATA],m[NDATA];
  double rt,en,xc,yc,vx,vy,sn,cs,xo,yo;
  int n,ndat,c[NDATA],nn;

  if(argc != 4){
    fprintf(stderr,"Usage : %s coo coolist trpar\n",argv[0]);
    exit(0);
  }
  fprintf(stderr,"Read: %s ... ",argv[1]);
  if((fpr = fopen(argv[1],"r")) == NULL){
    fprintf(stderr,"Cannot open %s\n",argv[1]);
    exit(0);
  }
  n=0;
  while(!feof(fpr)){
    if(fgets(buf,sizeof(buf),fpr)==NULL) break;
    if(buf[0]=='#') continue;
    if(sscanf(buf,"%f %f %f",&x[n],&y[n],&m[n])!=3){
      fprintf(stderr,"Cannot read (x,y,m)@: %s",buf);
      continue;
    }
    if(x[n]<50||LINEPIX-50<=x[n]||y[n]<60||LINEPIY-60<y[n]) continue;
    c[n]=n;
    n++;
  }
  fclose(fpr);
  fprintf(stderr,"OK\n");
  ndat=n;
  for(n=0;n<ndat;n++){
    nn=n+1;
    while(y[nn]-y[n]<-m[n]*2){
      if(m[n]*2<x[nn]-x[n] && x[nn]-x[n]<-m[n]*2) c[nn]=c[n];
      nn++;
    }
  }
  for(n=0;n<ndat;n++){
    m[n]=1.;
    if(c[n]!=n){
      x[c[n]]+=x[n];
      y[c[n]]+=y[n];
      m[c[n]]+=m[n];
      //fprintf(stderr,"%d %d %g %g %g %g %g\n",n,c[n],x[n],y[n],x[c[n]]/m[c[n]],y[c[n]]/m[c[n]],m[c[n]]);
    }
  }
  for(n=0;n<ndat;n++){
    x[n]/=m[n];
    y[n]/=m[n];
  }
  for(n=0;n<2;n++){
    fprintf(stderr,"Read: %s ...\n",argv[n+2]);
    if((fp[n] = fopen(argv[n+2],"r")) == NULL){
      fprintf(stderr,"Cannot open %s\n",argv[n+2]);
      exit(0);
    }
  }
  while(!feof(fp[0])&&!feof(fp[1])){
    if(fgets(buf,sizeof(buf),fp[0])==NULL) break;
    sscanf(buf,"%s",fname);
    if(fgets(buf,sizeof(buf),fp[1])==NULL) break;
    sscanf(buf,"%lf %lf %lf %lf %lf %lf",&rt,&en,&xc,&yc,&vx,&vy);
    sn=sin(-rt/180.*M_PI);
    cs=cos(-rt/180.*M_PI);

    fprintf(stderr,"Write: %s ... ",fname);
    fpw=fopen(fname,"w");
    for(n=0;n<ndat;n++){
      if(c[n]==n){
	xo=((x[n]-xc)*cs-(y[n]-yc)*sn)/en+xc-vx;
	yo=((x[n]-xc)*sn+(y[n]-yc)*cs)/en+yc-vy;
	fprintf(fpw,"%lf %lf\n",xo,yo);
      }
    }
    fclose(fpw);
    fprintf(stderr,"OK\n");
  }
  for(n=0;n<2;n++) fclose(fp[n]);
  return 0;
}
