#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define NDATA 10000

int main(int argc,char *argv[])
{
  FILE *fp;
  float x[NDATA],y[NDATA],dx[NDATA],dy[NDATA];
  double dxt,dyt,dr,dr2s,dr2smin,dr0,dra,drb,drc,r,a=0.,b=0.,c=0.,da,db,dc,thre=1000.;
  char buf[1024],dmy[32];
  int n,nd,ndat,i,j,k,imin,jmin,kmin,loop;
  if(argc != 2){
    fprintf(stderr,"Usage : %s data\n",argv[0]);
    exit(0);
  }
  fprintf(stderr,"Read: %s ...\n",argv[1]);
  if((fp = fopen(argv[1],"r")) == NULL){
    fprintf(stderr,"Cannot open %s\n",argv[1]);
    exit(0);
  }
  n=0;
  while(!feof(fp)){
    if(fgets(buf,sizeof(buf),fp)==NULL) continue;
    if(buf[0]=='#') continue;
    if(sscanf(buf,"%f %f %s %s %s %s %f %f",&x[n],&y[n],dmy,dmy,dmy,dmy,&dx[n],&dy[n])!=8){
      fprintf(stderr,"Truncated data?: %s",buf);
      exit(0);
    }
    n++;
    if(n==NDATA){
      fprintf(stderr,"NDATA is too small.\n");
      exit(0);
    }
  }
  fclose(fp);
  ndat=n;
  fprintf(stderr,"ndat=%d OK\n",ndat);
  for(loop=10;loop>=0;loop--){
    dr2smin=1e10;imin=1;jmin=1;kmin=1;da=1.;db=1.;dc=1.;
    while(da>1e-7){
      imin=0;jmin=0;kmin=0;dr2smin+=1e-8;
      for(i=-1;i<=1;i++){
	for(j=-1;j<=1;j++){
	  for(k=-1;k<=1;k++){
	    dr2s=0.;nd=0;
	    for(n=0;n<ndat;n++){
	      r=sqrt((x[n]-1110)*(x[n]-1110)+(y[n]-680)*(y[n]-680))/1000;
	      dxt=dx[n]+((a+da*k)+(b+db*j)*r*r+(c+dc*i)*r*r*r*r)*(x[n]-1110)/1000;
	      dyt=dy[n]+((a+da*k)+(b+db*j)*r*r+(c+dc*i)*r*r*r*r)*(y[n]-680)/1000;
	      dxt*=(x[n]-1110)/r/1000;
	      dyt*=(y[n]-680)/r/1000;
	      dr=sqrt(dxt*dxt+dyt*dyt);
	      if(dr<thre){
		dr2s+=dr*dr;
		nd++;
	      }
	    }
	    dr2s=sqrt(dr2s/nd);
	    //fprintf(stderr,"%2d%2d%2d: %7.5lf %7.5lf %7.5lf %6.3lf %6.3lf %6.3lf %9.7lf\n",i,j,k,da,db,dc,a+da*k,b+db*j,c+dc*i,dr2s);
	    if(dr2smin>dr2s){
	      dr2smin=dr2s;
	      imin=i;jmin=j;kmin=k;
	    }
	    if(i==0&&j==0&&k==0){
	      dr0=sqrt(dr2s);
	      dra=fabs(dra-dr0);
	      drb=fabs(drb-dr0);
	      drc=fabs(drc-dr0);
	    }
	    if(i==0&&j==0&&k==-1) dra=sqrt(dr2s);
	    if(i==0&&j==-1&&k==0) drb=sqrt(dr2s);
	    if(i==-1&&j==0&&k==0) drc=sqrt(dr2s);
	    if(i==0&&j==0&&k==1){
	      if(dra<fabs(sqrt(dr2s)-dr0)) dra=fabs(sqrt(dr2s)-dr0);
	    }
	    if(i==0&&j==1&&k==0){
	      if(drb<fabs(sqrt(dr2s)-dr0)) drb=fabs(sqrt(dr2s)-dr0);
	    }
	    if(i==1&&j==0&&k==0){
	      if(drc<fabs(sqrt(dr2s)-dr0)) drc=fabs(sqrt(dr2s)-dr0);
	    }
	  }
	}
      }
      a+=da*kmin;
      b+=db*jmin;
      c+=dc*imin;
      fprintf(stderr,"%2d%2d%2d: %7.5lf %7.5lf %7.5lf %6.3lf %6.3lf %6.3lf %9.7lf %d %d\r",imin,jmin,kmin,da,db,dc,a,b,c,dr2smin,nd,ndat);
      if(drb>10*dra) drb=10*dra;
      else if(drb<0.1*dra) drb=0.1*dra;
      if(drc>10*dra) drc=10*dra;
      else if(drc<0.1*dra) drc=0.1*dra;
      db*=dra/drb;
      dc*=dra/drc;
      if(imin==0&&jmin==0&&kmin==0){da/=10.;db/=10.;dc/=10.;}
    }
    fprintf(stderr,"\n");
    for(n=0;n<ndat;n++){
      r=sqrt((x[n]-1110)*(x[n]-1110)+(y[n]-680)*(y[n]-680))/1000;
      dxt=dx[n]+((a+da*k)+(b+db*j)*r*r+(c+dc*i)*r*r*r*r)*(x[n]-1110)/1000;
      dyt=dy[n]+((a+da*k)+(b+db*j)*r*r+(c+dc*i)*r*r*r*r)*(y[n]-680)/1000;
      dxt*=(x[n]-1110)/r/1000;
      dyt*=(y[n]-680)/r/1000;
      dr=sqrt(dxt*dxt+dyt*dyt);
      if(dr>dr2smin*4.){
	dx[n]=1e5;
	dy[n]=1e5;
      }
    }
  }
  //fprintf(stderr,"%6.3lf %6.3lf %6.3lf %9.7lf\n",a,b,c,dr2smin);
  return 0;
}
