#include <stdio.h>
#include <stdlib.h>
#include <math.h>

int main(int argc,char *argv[])
{
  FILE *fp[3],*fp0;
  char buf[1024],fname[128];
  double x0[3],y0[3],x[3],y[3],r[3],xc,yc,xs,ys,rs[3],as[3],rst;
  int ns,n;
  
  if(argc != 2){
    fprintf(stderr,"Usage : %s coolist\n",argv[0]);
    exit(0);
  }
  fprintf(stderr,"Read: %s ...\n",argv[1]);
  if((fp0 = fopen(argv[1],"r")) == NULL){
    fprintf(stderr,"Cannot open %s\n",argv[1]);
    exit(0);
  }
  for(n=0;n<3;n++){
    if(fgets(buf,sizeof(buf),fp0)==NULL){
      fprintf(stderr,"No data\n");
      exit(0);
    }
    sscanf(buf,"%s",fname);
    fprintf(stderr,"Read: %s ...\n",fname);
    if((fp[n] = fopen(fname,"r")) == NULL){
      fprintf(stderr,"Cannot open %s\n",fname);
      exit(0);
    }
    x0[n]=0.;
    y0[n]=0.;
  }
  fclose(fp0);
  ns=0;
  while(!feof(fp[0])&&!feof(fp[1])&&!feof(fp[2])){
    for(n=0;n<3;n++){
      if(fgets(buf,sizeof(buf),fp[n])==NULL) break;
      if(buf[0]=='#') continue;
      sscanf(buf,"%lf %lf",&x[n],&y[n]);
      x0[n]+=x[n];
      y0[n]+=y[n];
    }
    if(buf[0]=='#') continue;
    if(n!=3) break;
    ns++;
  }
  for(n=0;n<3;n++){
    x0[n]/=ns;
    y0[n]/=ns;
    rs[n]=0.;
    as[n]=0.;
    fseek(fp[n],0L,SEEK_SET);
  }  
  xs=0.;ys=0.;
  for(n=0;n<3;n++){
    xs+=x0[n];
    ys+=y0[n];
  }
  xc=xs/3.;
  yc=ys/3.;
  xc=x0[1]+floor(xc-x0[1]+0.5);
  yc=y0[1]+floor(yc-y0[1]+0.5);
  fprintf(stderr,"Number :  %d\n",ns);
  fprintf(stderr,"Center :  %+9.3lf %+9.3lf\n",xc,yc);
  fprintf(stderr,"Offset :");
  for(n=0;n<3;n++) fprintf(stderr,"  %+lf %+lf",xc-x0[n],yc-y0[n]);
  fprintf(stderr,"\n");
  while(!feof(fp[0])&&!feof(fp[1])&&!feof(fp[2])){
    for(n=0;n<3;n++){
      if(fgets(buf,sizeof(buf),fp[n])==NULL) break;
      if(buf[0]=='#') continue;
      sscanf(buf,"%lf %lf",&x[n],&y[n]);
      x[n]-=x0[n];
      y[n]-=y0[n];
      r[n]=sqrt(x[n]*x[n]+y[n]*y[n]);
    }
    if(buf[0]=='#') continue;
    if(n!=3) break;
    for(n=0;n<3;n++){
      rs[n]+=r[n];
      as[n]+=(x[n]*y[1]-y[n]*x[1])/r[n];
    }
  }
  rst=rs[1];
  for(n=0;n<3;n++){
    fclose(fp[n]);
    rs[n]/=rst;
    as[n]=asin(as[n]/rst)/M_PI*180;
  }
  fprintf(stderr,"Rot/Enl:");
  for(n=0;n<3;n++){
    fprintf(stderr,"  %+lf %+lf",as[n],1./rs[n]);
    printf("%lf %lf %lf %lf %lf %lf\n",as[n],1./rs[n],xc,yc,xc-x0[n],yc-y0[n]);
  }
  fprintf(stderr,"\n");
  //fprintf(stderr,"<tr><th></th>");
  //for(n=0;n<3;n+=2){
  //  fprintf(stderr,"<th>%+lf</th><th>%lf</th><th>(%+lf %+lf)</th>",as[n],1./rs[n],((1100-xc)*cos(as[n]/180*M_PI)-(680-yc)*sin(as[n]/180*M_PI))/rs[n]-(1100-xc)+xc-x0[n],((1100-xc)*sin(as[n]/180*M_PI)+(680-yc)*cos(as[n]/180*M_PI))/rs[n]-(680-yc)+yc-y0[n]);
  //}
  //fprintf(stderr,"<th></th></tr>\n");
  fprintf(stderr,"Append: mktrpar.log ... ");
  fp0 = fopen("mktrpar.log","a");
  fprintf(fp0,"%s  Rot/Enl:",argv[1]);
  for(n=0;n<3;n++) fprintf(fp0,"  %+lf %+lf",as[n],1./rs[n]);
  fprintf(fp0,"\n");
  fclose(fp0);
  fprintf(stderr,"OK\n");
  return 0;
}
